﻿using Hotline.Settings;
using Hotline.Share.Enums.Order;
using Hotline.Share.Requests;
using Microsoft.VisualBasic;
using XF.Utility.EnumExtensions;

namespace Hotline.Share.Dtos.Order
{
	public class OrderBiOrgDataListVo
	{
		public string OrgName { get; set; }

		public string OrgId { get; set; }

		/// <summary>
		/// 业务已办超期
		/// </summary>
		public int HandlerExtendedNum { get; set; }

		/// <summary>
		/// 会签已办超期
		/// </summary>
		public int CounterHandlerExtendedNum { get; set; }
		/// <summary>
		/// 业务待办超期
		/// </summary>
		public int NoHandlerExtendedNum { get; set; }
		/// <summary>
		/// 会签待办超期
		/// </summary>
		public int CounterNoHandlerExtendedNum { get; set; }

		public int Subtotal => HandlerExtendedNum + CounterHandlerExtendedNum + NoHandlerExtendedNum + CounterNoHandlerExtendedNum;
	}

	public class OrderBiCentreDataListVo
	{
		public string UserName { get; set; }

		public string UserId { get; set; }

		public int CentreArchive { get; set; }

		public int CentreCareOf { get; set; }

		public int NoCentreCareOf { get; set; }

		public int Invalid { get; set; }

		public int Repeat { get; set; }

		public int Subtotal => CentreArchive + CentreCareOf + NoCentreCareOf + Invalid + Repeat;
	}

	public class OrderBiSpecialListVo
	{
		public string Cause { get; set; }

		public int OrderNum { get; set; }

		public DateTime MaxSpecialTime { get; set; }
	}

	public class HotspotDataLsitVo { 
		public string Name { get; set;}

		public string Id { get; set; }

		public int Num { get; set; }
		public bool Sublevel { get; set; }

		List<HotspotDataLsitVo> Children { get; set; }
	}


	public class AcceptTypeTop10Volod {
		/// <summary>
		/// 热点名称
		/// </summary>
		public string Name { get; set; }

		/// <summary>
		/// 受理类型ID
		/// </summary>
		public string Id { get; set; }

		/// <summary>
		/// 受理类型名称
		/// </summary>
		public string AcceptName { get; set; }

		/// <summary>
		/// 数量
		/// </summary>
		public int Num { get; set; }
	}

	public class AcceptTypeTop10Vo
	{
		/// <summary>
		/// 热点名称
		/// </summary>
		public string Name { get; set; }

		/// <summary>
		/// 有效受理
		/// </summary>
		public int ValidAccept { get; set; }

		/// <summary>
		/// 咨询
		/// </summary>
		public int Consult { get; set; }

		/// <summary>
		/// 举报
		/// </summary>

		public int Report { get; set; }

		/// <summary>
		/// 投诉
		/// </summary>
		public int Complaint { get; set; }

		/// <summary>
		/// 求助
		/// </summary>
		public int SeekHelp { get; set; }

		/// <summary>
		/// 建议
		/// </summary>
		public int Suggest { get; set; }

		/// <summary>
		/// 意见
		/// </summary>
		public int Opinion { get; set; }

		/// <summary>
		/// 其他
		/// </summary>
		public int Rests { get; set; }

		/// <summary>
		/// 惠民帮助
		/// </summary>
		public int BenefitThePeople { get; set; }

		/// <summary>
		/// 表扬
		/// </summary>
		public int Praise { get; set; }
	}

	public class BiOrderDelayDataDto
	{
		/// <summary>
		/// 部门名称
		/// </summary>
		public string OrgName { get; set; }
		/// <summary>
		/// 部门code
		/// </summary>
		public string OrgCode { get; set; }
		/// <summary>
		/// 小计
		/// </summary>
		public int AllTotal { get; set; }
		/// <summary>
		/// 已同意次数
		/// </summary>
		public int PassTotal { get; set; }
		/// <summary>
		/// 未同意次数
		/// </summary>
		public int NoPassTotal { get; set; }
		/// <summary>
		/// 审批中次数
		/// </summary>
		public int ExaminingTotal { get; set; }

    }



	public class VisitMeasureStatisticsDto
	{
		

        /// <summary>
        /// 智能回访量
        /// </summary>
        public int AiVisitCount { get; set; }

        /// <summary>
        /// 智能回访满意量
        /// </summary>
        public int AiVisitSatisfiedCount { get; set; }

        /// <summary>
        /// 智能回访不满意量
        /// </summary>
        public int AiVisitNoSatisfiedCount { get; set; }

        /// <summary>
        /// 智能回访失败量
        /// </summary>
        public int AIVisitFailCount { get; set; }

		public List<VisitMeasureStatisticsModelDto> VisitMeasureStatisticsModelList { get; set; }
	
    }

	public class VisitMeasureStatisticsModelDto
	{
        /// <summary>
        /// 回访员
        /// </summary>
        public string VisitName { get; set; }

        /// <summary>
        /// 电话回访
        /// </summary>
        public int CallVisitCount { get; set; }
        /// <summary>
        /// 人工回访
        /// </summary>
        public int ArtificialVisitCount { get; set; }
        /// <summary>
        /// 总回访量
        /// </summary>
        public int SumCount { get; set; }
    }



    public class VisitAndOrgSatisfactionStatisticsResultDto
	{
		public List<VisitAndOrgSatisfactionStatisticsDto> DataList { get; set; }

		public VisitAndOrgSatisfactionStatisticsDto CountySumModel { get; set; }

		public VisitAndOrgSatisfactionStatisticsDto CitySumModel { get; set; }

		public VisitAndOrgSatisfactionStatisticsDto SumModel { get; set; }
    }




    public class VisitAndOrgSatisfactionStatisticsDto
	{
		public string OrgName { get; set; }

		public string OrgCode { get; set; }

		public EOrgType? OrgType { get; set; }

		public string OrgTypeText => OrgType?.GetDescription();

		/// <summary>
		/// 总数
		/// </summary>
		public int TotalSumCount { get; set; }

		/// <summary>
		/// 总满意度
		/// </summary>
		public double TotalSumRate => Math.Round(VerySatisfiedRate + SatisfiedRate + RegardedAsSatisfiedRate+ DefaultSatisfiedRate, 2);

		/// <summary>
		/// 非常满意数
		/// </summary>
		public int VerySatisfiedCount { get; set; }

		/// <summary>
		/// 非常满意Key
		/// </summary>
		public string VerySatisfiedKey => "5";

		/// <summary>
		/// 非常满意率
		/// </summary>
		public double VerySatisfiedRate => CalcVerySatisfiedRate();

		public double CalcVerySatisfiedRate()
		{
			if (VerySatisfiedCount == 0 || TotalSumCount == 0)
			{
				return 0;
			}
			return Math.Round((VerySatisfiedCount / (double)TotalSumCount) * 100, 2);
		}

		/// <summary>
		/// 满意数
		/// </summary>
		public int SatisfiedCount { get; set; }

		/// <summary>
		/// 满意Key
		/// </summary>
		public string SatisfiedKey => "4";

		/// <summary>
		/// 满意率
		/// </summary>
		public double SatisfiedRate => CalcSatisfiedRate();


		public double CalcSatisfiedRate()
		{
			if (SatisfiedCount == 0 || TotalSumCount == 0)
			{
				return 0;
			}
			return Math.Round((SatisfiedCount / (double)TotalSumCount) * 100, 2);
		}


		/// <summary>
		/// 视为满意数
		/// </summary>
		public int RegardedAsSatisfiedCount { get; set; }

		/// <summary>
		/// 视为满意Key
		/// </summary>
		public string RegardedAsSatisfiedKey => "-1";

		/// <summary>
		/// 视为满意率
		/// </summary>
		public double RegardedAsSatisfiedRate => CalcRegardedAsSatisfiedRate();

		public double CalcRegardedAsSatisfiedRate()
		{
            if (RegardedAsSatisfiedCount == 0 || TotalSumCount == 0)
            {
                return 0;
            }
            return Math.Round((RegardedAsSatisfiedCount / (double)TotalSumCount) * 100, 2);
        }

		/// <summary>
		/// 默认满意数
		/// </summary>
		public int DefaultSatisfiedCount { get; set; }

		/// <summary>
		/// 默认满意Key
		/// </summary>
		public string DefaultSatisfiedKey => "0";

		/// <summary>
		/// 默认满意率
		/// </summary>
		public double DefaultSatisfiedRate => CalcDefaultSatisfiedRate();

		public double CalcDefaultSatisfiedRate()
		{
            if (DefaultSatisfiedCount == 0 || TotalSumCount == 0)
            {
                return 0;
            }
            return Math.Round((DefaultSatisfiedCount / (double)TotalSumCount) * 100, 2);
        }

        /// <summary>
        /// 不满意数
        /// </summary>
        public int NoSatisfiedCount { get; set; }

		/// <summary>
		/// 不满意Key
		/// </summary>
		public string NoSatisfiedKey => "2";

		/// <summary>
		/// 不满意率
		/// </summary>
		public double NoSatisfiedRate => CalcNoSatisfiedRate();


		public double CalcNoSatisfiedRate()
		{
			if (NoSatisfiedCount == 0 || TotalSumCount == 0)
			{
				return 0;
			}
			return Math.Round((NoSatisfiedCount / (double)TotalSumCount) * 100, 2);
		}



		/// <summary>
		/// 未做评价数
		/// </summary>
		public int NoEvaluateCount { get; set; }

		/// <summary>
		/// 未做评价Key
		/// </summary>
		public string NoEvaluateKey => "7";

		/// <summary>
		/// 未做评价率
		/// </summary>
		public double NoEvaluateRate => CalcNoEvaluateRate();


		public double CalcNoEvaluateRate()
		{
			if (NoEvaluateCount == 0 || TotalSumCount == 0)
			{
				return 0;
			}
			return Math.Round((NoEvaluateCount / (double)TotalSumCount) * 100, 2);
		}



		/// <summary>
		/// 未接通数
		/// </summary>
		public int NoPutThroughCount { get; set; }

		/// <summary>
		/// 未接通Key
		/// </summary>
		public string NoPutThroughKey => "6";

		/// <summary>
		/// 未接通率
		/// </summary>
		public double NoPutThroughRate => CalcNoPutThroughRate();


        public double CalcNoPutThroughRate()
		{
            if (NoPutThroughCount == 0 || TotalSumCount == 0)
            {
                return 0;
            }
            return Math.Round((NoPutThroughCount / (double)TotalSumCount) * 100, 2);
        }
    }

	public class BiOrderSendDto { 
	
	} 
}
